/* 
 * $Id: GLSDImportModule.h,v 1.3 2006/06/29 07:26:42 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.3 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___GLSDIMPORTMODULE_H
#define ___GLSDIMPORTMODULE_H

#include "glibmm.h"
#include "libxml/tree.h"

#include "XDTPTransform.h"

namespace XDTP {

class GLSDImportModule
{
public:
	virtual ~GLSDImportModule();

    /**
     * 򳫻Ϥ˽Ϸꤷޤ
     * 
     * @param aType Ϸ
     */
    virtual void setOutputType(const Glib::ustring& aType) = 0;
    
    /**
     * 򳫻Ϥ˥ץꤷޤ
     * 
     * @param anOptions ץ
     */
    virtual void setOption(const StringList& anOptions) = 0;

    /**
     * 򳫻Ϥ˽ϥե̾ꤷޤ
     * 
     * @param anOutputFile ϥե̾
     */
    virtual void setOutputFile(const Glib::ustring& anOutputFile) = 0;

    /**
     * 򳫻ϤѴXMLե̾ꤷޤ
     * 
     * @param aXMLFile ѴXMLե̾
     */
    virtual void setXMLFile(const Glib::ustring& aXMLFile) = 0;
    
    /**
     * ϥեΥ󥳡ɤꤷޤ
     * XMLեϤθ¤ǤϤޤ
     * 
     * @param anInputEncoding ϥեΥ󥳡
     */
    virtual void setInputEncoding(const Glib::ustring& anInputEncoding) = 0;

    /**
     * ϥեΥ󥳡ɤꤷޤ
     * 
     * @param anOutputEncoding ϥեΥ󥳡
     */
    virtual void setOutputEncoding(const Glib::ustring& anOutputEncoding) = 0;

    /**
     * ߤXDTPTransform⥸塼ꤷޤ
     * 
     * @param aXDTPTransform ߤXDTPTransform⥸塼
     */
    virtual void setXDTPTransform(const XDTPTransform *aXDTPTransform) = 0;

    /**
     * XMLեΥ󥳡ǥ󥰤ꤷޤ
     * 
     * @param anEncoding XMLեΥ󥳡ǥ
     */
    virtual void setXMLEncoding(const std::string& anEncoding) = 0;

    /**
     * եparseľ˸ƤӽФޤ
     * 
     * @param aFile parseоݤΥե̾
     */
    virtual void treatPreFile(const Glib::ustring& aFile) = 0;

    /**
     * parseXMLʸϤXSLѴľ˸ƤӽФޤ
     * 
     * @param aDocument XMLʸ
     */
    virtual void treatPreDocument(xmlDocPtr aDocument) = 0;

    /**
     * XSLѴXMLʸϤ¸ľ˸ƤӽФޤ
     * 
     * @param aDocument XMLʸ
     */
    virtual void treatPostDocument(xmlDocPtr aDocument) = 0;

    /**
     * XMLʸϤ¸ľ˸ƤӽФޤ
     * 
     * @param aFile ¸ե̾
     */
    virtual void treatPostFile(const Glib::ustring& aFile) = 0;

protected:
    GLSDImportModule();

    /**
     * ߤXDTPTransform⥸塼ޤ
     * 
     * @return ߤXDTPTransform⥸塼
     */
    virtual const XDTPTransform * getXDTPTransform() = 0;
};

};

#endif
