<?xml version="1.0" encoding="EUC-JP"?>

<!--
 * $Id: GLSDocumentModule.xsl,v 1.7 2006/06/20 10:56:18 ozawa Exp $
 *
 * Copyright (c) 2003- ONGS Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
-->

<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

 <xsl:output method="text" encoding="EUC-JP" indent="no"/>

 <xsl:strip-space elements="/document"/>

<!-- إåʬ -->
 <xsl:template match="/document/docgroup">
  <text><xsl:apply-templates/></text>
 </xsl:template>

<!-- ɥȾ -->
 <xsl:template match="/document/docgroup//docgroup">
  <xsl:for-each select="preceding-sibling::*[position()=1]">
   <xsl:if test="name() != 'docgroup'">
    <xsl:call-template name="newline"/>
   </xsl:if>
  </xsl:for-each>
  <xsl:apply-templates/>
  <xsl:for-each select="child::*[position()=last()]">
   <xsl:if test="name() != 'docgroup'">
    <xsl:call-template name="newline"/>
   </xsl:if>
  </xsl:for-each>
 </xsl:template>
 
 <xsl:template name="docinfo-import" match="docinfo">
  <xsl:param name="root_docinfo_newline" select="1"/>

  <xsl:choose>
   <!-- /document/docgroup/docinfo ν -->
   <xsl:when test="count(ancestor::docgroup) = 1">
    <xsl:for-each select="title[1]/p">
     <xsl:text> </xsl:text><xsl:apply-templates/><xsl:text></xsl:text>
     <xsl:call-template name="newline"/>
    </xsl:for-each>
    <xsl:call-template name="newline"/>
    <xsl:call-template name="docinfo">
     <xsl:with-param name="newline" select="0"/>
    </xsl:call-template>
    <xsl:if test="$root_docinfo_newline = 1">
     <xsl:call-template name="newline"/>
    </xsl:if>
   </xsl:when>

   <!-- /document/docgroup//docgroup/docinfo ν -->
   <xsl:otherwise>
    <xsl:call-template name="title"/>
    <xsl:call-template name="docinfo">
     <xsl:with-param name="newline" select="0"/>
    </xsl:call-template>
    <xsl:for-each select="following-sibling::*[position()=1]">
     <xsl:if test="name() != 'docgroup'">
      <xsl:call-template name="newline"/>
     </xsl:if>
    </xsl:for-each>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="title">
  <xsl:variable name="startnumber" select="/document/docgroup/docinfo/initialnumber[1]/text()"/>
  <xsl:variable name="basenumber"><xsl:number level="multiple" count="/document/docgroup//docgroup"/></xsl:variable>

  <xsl:for-each select="title[1]/p">
   <xsl:choose>
    <xsl:when test="1 &lt; $startnumber">
     <xsl:choose>
      <xsl:when test="0 &lt; string-length(substring-before($basenumber, '.'))">
       <xsl:value-of select="$startnumber -1 + number(substring-before($basenumber, '.'))"/><xsl:value-of select="concat('.', substring-after($basenumber, '.'))"/>
      </xsl:when>
      <xsl:otherwise>
       <xsl:value-of select="$startnumber -1 + number($basenumber)"/>
      </xsl:otherwise>
     </xsl:choose>
    </xsl:when>
    <xsl:otherwise>
     <xsl:value-of select="$basenumber"/>
    </xsl:otherwise>
   </xsl:choose>
   <xsl:text> </xsl:text>
   <xsl:apply-templates/><xsl:call-template name="newline"/>
  </xsl:for-each>
 </xsl:template>

 <!-- docinfo  -->
 <xsl:template name="docinfo">
  <xsl:param name="newline"/>

  <xsl:for-each select="author/p">
   <xsl:text> </xsl:text>
   <xsl:apply-templates/><xsl:call-template name="newline"/>
  </xsl:for-each>

  <xsl:for-each select="firstedition/p">
   <xsl:text>ǯ </xsl:text>
   <xsl:apply-templates/><xsl:call-template name="newline"/>
  </xsl:for-each>

  <xsl:for-each select="lastmodified/p">
   <xsl:text>ǯ </xsl:text>
   <xsl:apply-templates/><xsl:call-template name="newline"/>
  </xsl:for-each>

  <xsl:for-each select="copyright/p">
   <xsl:text> </xsl:text>
   <xsl:apply-templates/><xsl:call-template name="newline"/>
  </xsl:for-each>

  <xsl:if test="$newline = 1">
   <xsl:if test="count(author | firstedition | lastmodified | copyright) > 0">
    <xsl:call-template name="newline"/>
   </xsl:if>
  </xsl:if>
 </xsl:template>

 <xsl:template match="p">
  <xsl:apply-templates/>
  <xsl:call-template name="newline"/>

  <!-- ƤdocgroupξȤƤβԤɲá -->
  <xsl:for-each select="parent::node()">
   <xsl:if test="name() = 'docgroup'">
    <xsl:call-template name="newline"/>
   </xsl:if>
  </xsl:for-each>
 </xsl:template>

 <xsl:template match="p/text()">
  <xsl:value-of select="."/>
 </xsl:template>

 <xsl:template match="text()">
 </xsl:template>

 <xsl:template name="newline">
  <xsl:text>
</xsl:text>
 </xsl:template>

</xsl:stylesheet>
